<?php
/**
 * Page-Data-Scripting - main index.php
 * Plugin (V.2.1-compatible)
 *
 * Stores page-dependend scriptings (plugin-calls etc.)
 * and let the user take control of activation
 * on the page.
 * index.php is called by pluginloader
 *
 * @author Holger Irmler
 * @link http://www.HolgerIrmler.de/playground
 * @version 2.0
 * @date: 2010-04-02
 * @package hi_pd_scripting
 */

define('HI_PDS_MAIN', '2.0'); 
define('HI_PDS_INDEX', '2.0');
 
//Check if PLUGINLOADER is calling and DIE if not
if(!defined('PLUGINLOADER_VERSION')){die('Plugin '. basename(dirname(__FILE__)) . ' requires a newer version of the Pluginloader. No direct access.');} 

// set a maximum allowed value of pd_fields to prevent pollution of pagedata.php
define('HI_PD_SCRIPTING_MAX', 5);
if (!isset($plugin_cf['hi_pd_scripting']['scripts_max_on_page']) || $plugin_cf['hi_pd_scripting']['scripts_max_on_page'] == '' || $plugin_cf['hi_pd_scripting']['scripts_max_on_page'] > HI_PD_SCRIPTING_MAX) {
	$plugin_cf['hi_pd_scripting']['scripts_max_on_page'] = HI_PD_SCRIPTING_MAX;
}
if ($plugin_cf['hi_pd_scripting']['mode_advanced'] !== '1'){
	$plugin_cf['hi_pd_scripting']['scripts_max_on_page'] = 1; //remember: will be also saved in config.php
}

// Add used interests to router
for ($i = 1; $i <= $plugin_cf['hi_pd_scripting']['scripts_max_on_page']; $i++) {
	$pd_router -> add_interest('hi_pd_scripting_active'.$i);
	$pd_router -> add_interest('hi_pd_scripting_code'.$i);
	$pd_router -> add_interest('hi_pd_scripting_placeholder'.$i);
}

// Add a tab for admin-menu if not hidden by plugin-config
if ($plugin_cf['hi_pd_scripting']['tab_hide_from_user'] !== '1') {
	$pd_router -> add_tab($plugin_tx['hi_pd_scripting']['tab'], $pth['folder']['plugins'].'hi_pd_scripting/hi_pd_scripting_view.php');
}

##########################################
//build scriptcalls and add to page
$hi_pds_vars = '';
$hi_pds_out = '';
$hi_pds_dummy = '';
$hi_pds_errors = '';

for ($i = 1; $i <= $plugin_cf['hi_pd_scripting']['scripts_max_on_page']; $i++) {
	//process, if script is activated and a scripcode was given
	$pd_current['hi_pd_scripting_code'.$i]= trim($pd_current['hi_pd_scripting_code'.$i]);
	if(($pd_current['hi_pd_scripting_active'.$i] == '1') && ($pd_current['hi_pd_scripting_code'.$i] !== '')){
		//check if we deal only with variables
		if (substr($pd_current['hi_pd_scripting_code'.$i], 0, 1) == '$') {
			$hi_pds_vars .= $pd_current['hi_pd_scripting_code'.$i].' ';
		} else {
		//we're dealing with a function
		//remove last ";" if in scriptcode
		if (substr($pd_current['hi_pd_scripting_code'.$i], -1, 1) == ';') {
			$pd_current['hi_pd_scripting_code'.$i] = substr($pd_current['hi_pd_scripting_code'.$i],0,strlen($pd_current['hi_pd_scripting_code'.$i])-1);
		}
		//check for a placeholder in page-content or create an error and a dummy-placeholder
		if (strpos($c[$pd_s], $pd_current['hi_pd_scripting_placeholder'.$i]) === false) {
			if ($pd_current['hi_pd_scripting_placeholder'.$i] !== ''){
				$hi_pds_errors .= '<div class="pds_errors"><b>Error:</b> Placeholder "<i>'.$pd_current['hi_pd_scripting_placeholder'.$i].'</i>" not found!</div>';
			}
			$pd_current['hi_pd_scripting_placeholder'.$i] = 'hi_pd_scripting-DUMMY_'.$i;
			$hi_pds_dummy .= $pd_current['hi_pd_scripting_placeholder'.$i];
		}
		if (($i > 1)&&(strlen($hi_pds_out) > 0)) { 
			$hi_pds_out = $hi_pds_out . ',$output); ';
		}
		$hi_pds_out .= '$output = preg_replace("/'.$pd_current['hi_pd_scripting_placeholder'.$i].'/", '.$pd_current['hi_pd_scripting_code'.$i];
		}
	}
}
//complete the scriptcalls depending on pd-setting 'linked_to_menu'
//scriptings are given...
if (strlen($hi_pds_out) > 0) {
	$hi_pds_out = '#CMSimple '.$hi_pds_vars.$hi_pds_out;
	if ($pd_current['linked_to_menu'] == '0') {
		$hi_pds_out .= '.chr(35)."CMSimple hide".chr(35)';
	}
	$hi_pds_out .= ',$output);#';
} else {
	//no scripting, but changed variables...
	if (strlen($hi_pds_vars) > 0) {
		$hi_pds_out = '#CMSimple '.$hi_pds_vars.' #';
	}
}

//var_dump($hi_pds_vars);
//var_dump($hi_pds_out);
##########################################

//Display errors about not found placeholders in Admin-Mode: 
if(($adm) && ($plugin_cf['hi_pd_scripting']['mode_advanced'] == '1')){
	$o .= $hi_pds_errors;
}
//and .. action:
if(!$adm OR ($adm && !$edit)){
	$c[$pd_s] .= $hi_pds_dummy; //add placeholders after page-content
	$c[$pd_s] .= $hi_pds_out; //add scripting-codes
}
?>